Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2801)
@@ -739,7 +805,7 @@
           ALLOCATE( cl_coord_y(-nbgp:ny_cl+nbgp) )
          
-          CALL pmc_recv_from_child( child_id, cl_coord_x, SIZE( cl_coord_x ),   &
+          CALL pmc_recv_from_child( child_id, cl_coord_x, SIZE( cl_coord_x ),  &
                0, 11, ierr )
-          CALL pmc_recv_from_child( child_id, cl_coord_y, SIZE( cl_coord_y ),   &
+          CALL pmc_recv_from_child( child_id, cl_coord_y, SIZE( cl_coord_y ),  &
                0, 12, ierr )
          
@@ -761,5 +827,5 @@
              right_limit = parent_grid_info_real(5)
              north_limit = parent_grid_info_real(6)
-             IF ( ( cl_coord_x(nx_cl+1) /= right_limit ) .OR.                   &
+             IF ( ( cl_coord_x(nx_cl+1) /= right_limit ) .OR.                  &
                   ( cl_coord_y(ny_cl+1) /= north_limit ) )  THEN
                 nomatch = 1
@@ -774,7 +840,7 @@
              south_limit = lower_left_coord_y + yez
              north_limit = parent_grid_info_real(6) - yez
-             IF ( ( cl_coord_x(0) < left_limit )        .OR.                    &
-                  ( cl_coord_x(nx_cl+1) > right_limit ) .OR.                    &
-                  ( cl_coord_y(0) < south_limit )       .OR.                    &
+             IF ( ( cl_coord_x(0) < left_limit )        .OR.                   &
+                  ( cl_coord_x(nx_cl+1) > right_limit ) .OR.                   &
+                  ( cl_coord_y(0) < south_limit )       .OR.                   &
                   ( cl_coord_y(ny_cl+1) > north_limit ) )  THEN
                 nomatch = 1
@@ -785,4 +851,5 @@
 !--       that the top ghost layer of the child grid does not exceed 
 !--       the parent domain top boundary.
+
           IF ( cl_height > zw(nz) ) THEN
              nomatch = 1
@@ -798,10 +865,15 @@
 
              IF ( m > 1 )  THEN
-                DO mm = 1, m-1
-                   IF ( ( ch_xl(m) < ch_xr(mm) .OR.                             &
-                          ch_xr(m) > ch_xl(mm) )  .AND.                         &
-                        ( ch_ys(m) < ch_yn(mm) .OR.                             &
-                          ch_yn(m) > ch_ys(mm) ) )  THEN                        
-                      nest_overlap = 1
+                DO mm = 1, m - 1
+                   mid = pmc_parent_for_child(mm)
+!
+!--                Check Only different nest level
+                   IF (m_couplers(child_id)%parent_id /= m_couplers(mid)%parent_id)  THEN
+                      IF ( ( ch_xl(m) < ch_xr(mm) .OR.                         &
+                             ch_xr(m) > ch_xl(mm) )  .AND.                     &
+                           ( ch_ys(m) < ch_yn(mm) .OR.                         &
+                             ch_yn(m) > ch_ys(mm) ) )  THEN
+                         nest_overlap = 1
+                      ENDIF
                    ENDIF
                 ENDDO
@@ -809,18 +881,20 @@
           ENDIF
 
+          CALL set_child_edge_coords
+
           DEALLOCATE( cl_coord_x )
           DEALLOCATE( cl_coord_y )
 !
 !--       Send coarse grid information to child
-          CALL pmc_send_to_child( child_id, parent_grid_info_real,              &
-                                   SIZE( parent_grid_info_real ), 0, 21,        &
+          CALL pmc_send_to_child( child_id, parent_grid_info_real,             &
+                                   SIZE( parent_grid_info_real ), 0, 21,       &
                                    ierr )
-          CALL pmc_send_to_child( child_id, parent_grid_info_int,  3, 0,        &
+          CALL pmc_send_to_child( child_id, parent_grid_info_int,  3, 0,       &
                                    22, ierr )
 !
 !--       Send local grid to child
-          CALL pmc_send_to_child( child_id, coord_x, nx+1+2*nbgp, 0, 24,        &
+          CALL pmc_send_to_child( child_id, coord_x, nx+1+2*nbgp, 0, 24,       &
                                    ierr )
-          CALL pmc_send_to_child( child_id, coord_y, ny+1+2*nbgp, 0, 25,        &
+          CALL pmc_send_to_child( child_id, coord_y, ny+1+2*nbgp, 0, 25,       &
                                    ierr )
 !
@@ -835,5 +909,5 @@
        CALL MPI_BCAST( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
        IF ( nomatch /= 0 )  THEN
-          WRITE ( message_string, * )  'nested child domain does ',             &
+          WRITE ( message_string, * )  'nested child domain does ',            &
                                        'not fit into its parent domain'
           CALL message( 'pmci_setup_parent', 'PA0425', 3, 2, 0, 6, 0 )
@@ -847,4 +921,6 @@
       
        CALL MPI_BCAST( nz_cl, 1, MPI_INTEGER, 0, comm2d, ierr )
+       CALL MPI_BCAST( childgrid(m), c_sizeof(childgrid(1)), MPI_BYTE, 0, comm2d, ierr )
+
 !
 !--    TO_DO: Klaus: please give a comment what is done here
@@ -852,5 +928,8 @@
 !
 !--    Include couple arrays into parent content
-!--    TO_DO: Klaus: please give a more meaningful comment
+!--    The adresses of the PALM 2D or 3D array (here server coarse grid) which are candidates
+!--    for coupling are stored once into the pmc context. While data transfer, the array do not
+!--    have to be specified again
+
        CALL pmc_s_clear_next_array_list
        DO  WHILE ( pmc_s_getnextarray( child_id, myname ) )
@@ -881,24 +960,24 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                  !:
-       INTEGER(iwp) ::  ic                 !:
-       INTEGER(iwp) ::  ierr               !:
-       INTEGER(iwp) ::  j                  !:
-       INTEGER(iwp) ::  k                  !:
-       INTEGER(iwp) ::  m                  !:
-       INTEGER(iwp) ::  n                  !:
-       INTEGER(iwp) ::  npx                !:
-       INTEGER(iwp) ::  npy                !:
-       INTEGER(iwp) ::  nrx                !:
-       INTEGER(iwp) ::  nry                !:
-       INTEGER(iwp) ::  px                 !:
-       INTEGER(iwp) ::  py                 !:
-       INTEGER(iwp) ::  parent_pe          !:
-
-       INTEGER(iwp), DIMENSION(2) ::  scoord             !:
-       INTEGER(iwp), DIMENSION(2) ::  size_of_array      !:
-
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  coarse_bound_all   !:
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  index_list         !:
+       INTEGER(iwp) ::  i                  !<
+       INTEGER(iwp) ::  ic                 !<
+       INTEGER(iwp) ::  ierr               !<
+       INTEGER(iwp) ::  j                  !<
+       INTEGER(iwp) ::  k                  !<
+       INTEGER(iwp) ::  m                  !<
+       INTEGER(iwp) ::  n                  !<
+       INTEGER(iwp) ::  npx                !<
+       INTEGER(iwp) ::  npy                !<
+       INTEGER(iwp) ::  nrx                !<
+       INTEGER(iwp) ::  nry                !<
+       INTEGER(iwp) ::  px                 !<
+       INTEGER(iwp) ::  py                 !<
+       INTEGER(iwp) ::  parent_pe          !<
+
+       INTEGER(iwp), DIMENSION(2) ::  scoord             !<
+       INTEGER(iwp), DIMENSION(2) ::  size_of_array      !<
+
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  coarse_bound_all   !<
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  index_list         !<
 
        IF ( myid == 0 )  THEN
@@ -907,5 +986,5 @@
           CALL pmc_recv_from_child( child_id, size_of_array, 2, 0, 40, ierr )
           ALLOCATE( coarse_bound_all(size_of_array(1),size_of_array(2)) )
-          CALL pmc_recv_from_child( child_id, coarse_bound_all,                 &
+          CALL pmc_recv_from_child( child_id, coarse_bound_all,                &
                                     SIZE( coarse_bound_all ), 0, 41, ierr )
 !
@@ -983,4 +1062,37 @@
      END SUBROUTINE pmci_create_index_list
 
+     SUBROUTINE set_child_edge_coords
+        IMPLICIT  NONE
+
+        INTEGER(iwp) :: nbgp_lpm = 1
+
+        nbgp_lpm = min(nbgp_lpm, nbgp)
+
+        childgrid(m)%nx = nx_cl
+        childgrid(m)%ny = ny_cl
+        childgrid(m)%nz = nz_cl
+        childgrid(m)%dx = dx_cl
+        childgrid(m)%dy = dy_cl
+        childgrid(m)%dz = dz_cl
+
+        childgrid(m)%lx_coord   = cl_coord_x(0)
+        childgrid(m)%lx_coord_b = cl_coord_x(-nbgp_lpm)
+        childgrid(m)%rx_coord   = cl_coord_x(nx_cl)+dx_cl
+        childgrid(m)%rx_coord_b = cl_coord_x(nx_cl+nbgp_lpm)+dx_cl
+        childgrid(m)%sy_coord   = cl_coord_y(0)
+        childgrid(m)%sy_coord_b = cl_coord_y(-nbgp_lpm)
+        childgrid(m)%ny_coord   = cl_coord_y(ny_cl)+dy_cl
+        childgrid(m)%ny_coord_b = cl_coord_y(ny_cl+nbgp_lpm)+dy_cl
+        childgrid(m)%uz_coord   = zmax_coarse(2)
+        childgrid(m)%uz_coord_b = zmax_coarse(1)
+
+        WRITE(9,*)                 'edge coordinates for child id ',child_id,m
+        WRITE(9,*)                 'Number of Boundray cells lpm  ',nbgp_lpm
+        WRITE(9,'(a,3i7,2f10.2)') ' model size                    ', nx_cl, ny_cl, nz_cl, dx_cl, dy_cl
+        WRITE(9,'(a,5f10.2)')     ' model edge                    ', childgrid(m)%lx_coord, childgrid(m)%rx_coord, childgrid(m)%sy_coord, childgrid(m)%ny_coord,childgrid(m)%uz_coord
+        WRITE(9,'(a,4f10.2)')     ' model edge with Boundary      ', childgrid(m)%lx_coord_b, childgrid(m)%rx_coord_b, childgrid(m)%sy_coord_b, childgrid(m)%ny_coord_b
+
+     END SUBROUTINE set_child_edge_coords
+
 #endif
  END SUBROUTINE pmci_setup_parent
@@ -1005,16 +1117,17 @@
     INTEGER(iwp) ::  n          !< running index for number of chemical species
 
-    INTEGER(iwp), DIMENSION(5) ::  val        !:
+    INTEGER(iwp), DIMENSION(5) ::  val        !<
     
-    REAL(wp) ::  xcs        !:
-    REAL(wp) ::  xce        !:
-    REAL(wp) ::  ycs        !:
-    REAL(wp) ::  yce        !:
-
-    REAL(wp), DIMENSION(1) ::  fval       !:
+    REAL(wp) ::  xcs        !<
+    REAL(wp) ::  xce        !<
+    REAL(wp) ::  ycs        !<
+    REAL(wp) ::  yce        !<
+
+    REAL(wp), DIMENSION(5) ::  fval       !<
                                              
 !
-!-- TO_DO: describe what is happening in this if-clause
-!-- Root model does not have a parent and is not a child
+!-- Child setup
+!-- Root model does not have a parent and is not a child, therefore no child setup on root model
+
     IF ( .NOT. pmc_is_rootmodel() )  THEN
 
@@ -1057,4 +1170,9 @@
        ENDIF
 
+       IF( particle_advection )  THEN
+          CALL pmc_set_dataarray_name( 'coarse', 'nr_part'  ,'fine', 'nr_part',  ierr )
+          CALL pmc_set_dataarray_name( 'coarse', 'part_adr'  ,'fine', 'part_adr',  ierr )
+       ENDIF
+       
        IF ( air_chemistry )  THEN
           DO  n = 1, nspec
@@ -1078,4 +1196,8 @@
        val(5)  = dy
        fval(1) = zw(nzt+1)
+       fval(2) = zw(nzt)
+       fval(3) = dx
+       fval(4) = dy
+       fval(5) = dz
 
        IF ( myid == 0 )  THEN
@@ -1087,23 +1209,23 @@
 !
 !--       Receive Coarse grid information.
-          CALL pmc_recv_from_parent( parent_grid_info_real,                     &
+          CALL pmc_recv_from_parent( parent_grid_info_real,                    &
                                      SIZE(parent_grid_info_real), 0, 21, ierr )
           CALL pmc_recv_from_parent( parent_grid_info_int,  3, 0, 22, ierr )
 !
 !--        Debug-printouts - keep them
-!          WRITE(0,*) 'Coarse grid from parent '
-!          WRITE(0,*) 'startx_tot    = ',parent_grid_info_real(1)
-!          WRITE(0,*) 'starty_tot    = ',parent_grid_info_real(2)
-!          WRITE(0,*) 'endx_tot      = ',parent_grid_info_real(5)
-!          WRITE(0,*) 'endy_tot      = ',parent_grid_info_real(6)
-!          WRITE(0,*) 'dx            = ',parent_grid_info_real(3)
-!          WRITE(0,*) 'dy            = ',parent_grid_info_real(4)
-!          WRITE(0,*) 'dz            = ',parent_grid_info_real(7)
-!          WRITE(0,*) 'nx_coarse     = ',parent_grid_info_int(1)
-!          WRITE(0,*) 'ny_coarse     = ',parent_grid_info_int(2)
-!          WRITE(0,*) 'nz_coarse     = ',parent_grid_info_int(3)
-       ENDIF
-
-       CALL MPI_BCAST( parent_grid_info_real, SIZE(parent_grid_info_real),      &
+!           WRITE(0,*) 'Coarse grid from parent '
+!           WRITE(0,*) 'startx_tot    = ',parent_grid_info_real(1)
+!           WRITE(0,*) 'starty_tot    = ',parent_grid_info_real(2)
+!           WRITE(0,*) 'endx_tot      = ',parent_grid_info_real(5)
+!           WRITE(0,*) 'endy_tot      = ',parent_grid_info_real(6)
+!           WRITE(0,*) 'dx            = ',parent_grid_info_real(3)
+!           WRITE(0,*) 'dy            = ',parent_grid_info_real(4)
+!           WRITE(0,*) 'dz            = ',parent_grid_info_real(7)
+!           WRITE(0,*) 'nx_coarse     = ',parent_grid_info_int(1)
+!           WRITE(0,*) 'ny_coarse     = ',parent_grid_info_int(2)
+!           WRITE(0,*) 'nz_coarse     = ',parent_grid_info_int(3)
+       ENDIF
+
+       CALL MPI_BCAST( parent_grid_info_real, SIZE(parent_grid_info_real),     &
                        MPI_REAL, 0, comm2d, ierr )
        CALL MPI_BCAST( parent_grid_info_int, 3, MPI_INTEGER, 0, comm2d, ierr )
@@ -1158,5 +1280,5 @@
        n = 1
        DO  WHILE ( pmc_c_getnextarray( myname ) )
-!--       Note that cg%nz is not th eoriginal nz of parent, but the highest
+!--       Note that cg%nz is not the original nz of parent, but the highest
 !--       parent-grid level needed for nesting.
 !--       Please note, in case of chemical species an additional parameter
@@ -1186,5 +1308,5 @@
 !--    Precompute the index arrays and relaxation functions for the
 !--    anterpolation
-       IF ( TRIM( nesting_mode ) == 'two-way' .OR.                              &
+       IF ( TRIM( nesting_mode ) == 'two-way' .OR.                             &
                   nesting_mode == 'vertical' )  THEN
           CALL pmci_init_anterp_tophat
@@ -1206,11 +1328,11 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all   !:
-       INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !:
+       INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all   !<
+       INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !<
                                               
-       REAL(wp) ::  loffset     !:
-       REAL(wp) ::  noffset     !:
-       REAL(wp) ::  roffset     !:
-       REAL(wp) ::  soffset     !:
+       REAL(wp) ::  loffset     !<
+       REAL(wp) ::  noffset     !<
+       REAL(wp) ::  roffset     !<
+       REAL(wp) ::  soffset     !<
 
 !
@@ -1283,5 +1405,5 @@
 !--    Note that MPI_Gather receives data from all processes in the rank order
 !--    TO_DO: refer to the line where this fact becomes important
-       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5,      &
+       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5,     &
                         MPI_INTEGER, 0, comm2d, ierr )
 
@@ -1290,5 +1412,5 @@
           size_of_array(2) = SIZE( coarse_bound_all, 2 )
           CALL pmc_send_to_parent( size_of_array, 2, 0, 40, ierr )
-          CALL pmc_send_to_parent( coarse_bound_all, SIZE( coarse_bound_all ),  &
+          CALL pmc_send_to_parent( coarse_bound_all, SIZE( coarse_bound_all ), &
                                    0, 41, ierr )
        ENDIF
@@ -1306,27 +1428,27 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i       !:
-       INTEGER(iwp) ::  i1      !:
-       INTEGER(iwp) ::  j       !:
-       INTEGER(iwp) ::  j1      !:
-       INTEGER(iwp) ::  k       !:
-       INTEGER(iwp) ::  kc      !:
-       INTEGER(iwp) ::  kdzo    !:
-       INTEGER(iwp) ::  kdzw    !:       
-
-       REAL(wp) ::  xb          !:
-       REAL(wp) ::  xcsu        !:
-       REAL(wp) ::  xfso        !:
-       REAL(wp) ::  xcso        !:
-       REAL(wp) ::  xfsu        !:
-       REAL(wp) ::  yb          !:
-       REAL(wp) ::  ycso        !:
-       REAL(wp) ::  ycsv        !:
-       REAL(wp) ::  yfso        !:
-       REAL(wp) ::  yfsv        !:
-       REAL(wp) ::  zcso        !:
-       REAL(wp) ::  zcsw        !:
-       REAL(wp) ::  zfso        !:
-       REAL(wp) ::  zfsw        !:
+       INTEGER(iwp) ::  i       !<
+       INTEGER(iwp) ::  i1      !<
+       INTEGER(iwp) ::  j       !<
+       INTEGER(iwp) ::  j1      !<
+       INTEGER(iwp) ::  k       !<
+       INTEGER(iwp) ::  kc      !<
+       INTEGER(iwp) ::  kdzo    !<
+       INTEGER(iwp) ::  kdzw    !<       
+
+       REAL(wp) ::  xb          !<
+       REAL(wp) ::  xcsu        !<
+       REAL(wp) ::  xfso        !<
+       REAL(wp) ::  xcso        !<
+       REAL(wp) ::  xfsu        !<
+       REAL(wp) ::  yb          !<
+       REAL(wp) ::  ycso        !<
+       REAL(wp) ::  ycsv        !<
+       REAL(wp) ::  yfso        !<
+       REAL(wp) ::  yfsv        !<
+       REAL(wp) ::  zcso        !<
+       REAL(wp) ::  zcsw        !<
+       REAL(wp) ::  zfso        !<
+       REAL(wp) ::  zfsw        !<
       
 
@@ -1391,11 +1513,4 @@
           kcw(k) = kc - 1
           
-          !if ( myid == 0 .and. nx==191 )  then
-          !   write(162,*)nx, nzt+1, k, zw(k), cg%nz+1, kcw(k), cg%zw(kcw(k))
-          !endif
-          !if ( myid == 0 .and. nx==383 )  then
-          !   write(163,*)nx, nzt+1, k, zw(k), cg%nz+1, kcw(k), cg%zw(kcw(k))
-          !endif
-
           DO kc = 0, cg%nz+1
              IF ( cg%zu(kc) > zfso )  EXIT
@@ -1945,5 +2060,5 @@
                       inc        = 1
                       wall_index = j
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
                           k, j, inc, wall_index, z0_topo, kb, direction, ncorr )
 !
@@ -2188,23 +2303,23 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), INTENT(IN)  ::  direction                 !:
-       INTEGER(iwp), INTENT(IN)  ::  ij                        !:
-       INTEGER(iwp), INTENT(IN)  ::  inc                       !:
-       INTEGER(iwp), INTENT(IN)  ::  k                         !:
-       INTEGER(iwp), INTENT(IN)  ::  kb                        !:
-       INTEGER(iwp), INTENT(OUT) ::  lc                        !:
-       INTEGER(iwp), INTENT(IN)  ::  ncorr                     !:
-       INTEGER(iwp), INTENT(IN)  ::  wall_index                !:
-
-       INTEGER(iwp) ::  alcorr       !:
-       INTEGER(iwp) ::  corr_index   !:
-       INTEGER(iwp) ::  lcorr        !:
-
-       LOGICAL      ::  more         !:
-
-       REAL(wp), DIMENSION(0:ncorr-1), INTENT(OUT) ::  lcr     !:
-       REAL(wp), INTENT(IN)      ::  z0_l                      !:
+       INTEGER(iwp), INTENT(IN)  ::  direction  !<
+       INTEGER(iwp), INTENT(IN)  ::  ij         !<
+       INTEGER(iwp), INTENT(IN)  ::  inc        !<
+       INTEGER(iwp), INTENT(IN)  ::  k          !<
+       INTEGER(iwp), INTENT(IN)  ::  kb         !<
+       INTEGER(iwp), INTENT(OUT) ::  lc         !<
+       INTEGER(iwp), INTENT(IN)  ::  ncorr      !<
+       INTEGER(iwp), INTENT(IN)  ::  wall_index !<
+
+       INTEGER(iwp) ::  alcorr       !<
+       INTEGER(iwp) ::  corr_index   !<
+       INTEGER(iwp) ::  lcorr        !<
+
+       LOGICAL      ::  more         !<
+
+       REAL(wp), DIMENSION(0:ncorr-1), INTENT(OUT) ::  lcr     !<
+       REAL(wp), INTENT(IN)      ::  z0_l                      !<
       
-       REAL(wp)     ::  logvelc1     !:
+       REAL(wp)     ::  logvelc1     !<
       
 
@@ -2296,14 +2411,14 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), INTENT(IN)  ::  kb   !:
-       INTEGER(iwp), INTENT(OUT) ::  lc   !:
-
-       INTEGER(iwp) ::  kbc    !:
-       INTEGER(iwp) ::  k1     !:
-
-       REAL(wp), INTENT(OUT) ::  logzc1     !:
-       REAL(wp), INTENT(IN) ::  z0_l       !:
-
-       REAL(wp) ::  zuc1   !:
+       INTEGER(iwp), INTENT(IN)  ::  kb   !<
+       INTEGER(iwp), INTENT(OUT) ::  lc   !<
+
+       INTEGER(iwp) ::  kbc    !<
+       INTEGER(iwp) ::  k1     !<
+
+       REAL(wp), INTENT(OUT) ::  logzc1     !<
+       REAL(wp), INTENT(IN) ::  z0_l       !<
+
+       REAL(wp) ::  zuc1   !<
 
 
@@ -2335,15 +2450,15 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), INTENT(IN)  ::  inc    !:  increment must be 1 or -1.
-       INTEGER(iwp), INTENT(IN)  ::  j      !:
-       INTEGER(iwp), INTENT(IN)  ::  jw     !:
-       INTEGER(iwp), INTENT(OUT) ::  lc     !:
-
-       INTEGER(iwp) ::  j1       !:
-
-       REAL(wp), INTENT(IN) ::  z0_l   !:
-
-       REAL(wp) ::  logyc1   !:
-       REAL(wp) ::  yc1      !:
+       INTEGER(iwp), INTENT(IN)  ::  inc    !<  increment must be 1 or -1.
+       INTEGER(iwp), INTENT(IN)  ::  j      !<
+       INTEGER(iwp), INTENT(IN)  ::  jw     !<
+       INTEGER(iwp), INTENT(OUT) ::  lc     !<
+
+       INTEGER(iwp) ::  j1       !<
+
+       REAL(wp), INTENT(IN) ::  z0_l   !<
+
+       REAL(wp) ::  logyc1   !<
+       REAL(wp) ::  yc1      !<
        
 !
@@ -2376,15 +2491,15 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), INTENT(IN)  ::  i      !:
-       INTEGER(iwp), INTENT(IN)  ::  inc    !: increment must be 1 or -1.
-       INTEGER(iwp), INTENT(IN)  ::  iw     !:
-       INTEGER(iwp), INTENT(OUT) ::  lc     !:
-
-       INTEGER(iwp) ::  i1       !:
-
-       REAL(wp), INTENT(IN) ::  z0_l   !:
-
-       REAL(wp) ::  logxc1   !:
-       REAL(wp) ::  xc1      !:
+       INTEGER(iwp), INTENT(IN)  ::  i      !<
+       INTEGER(iwp), INTENT(IN)  ::  inc    !< increment must be 1 or -1.
+       INTEGER(iwp), INTENT(IN)  ::  iw     !<
+       INTEGER(iwp), INTENT(OUT) ::  lc     !<
+
+       INTEGER(iwp) ::  i1       !<
+
+       REAL(wp), INTENT(IN) ::  z0_l   !<
+
+       REAL(wp) ::  logxc1   !<
+       REAL(wp) ::  xc1      !<
 
 !
@@ -2417,20 +2532,20 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i        !: Fine-grid index
-       INTEGER(iwp) ::  ifc_o    !:
-       INTEGER(iwp) ::  ifc_u    !:
-       INTEGER(iwp) ::  ii       !: Coarse-grid index
-       INTEGER(iwp) ::  istart   !:
-       INTEGER(iwp) ::  ir       !:
-       INTEGER(iwp) ::  j        !: Fine-grid index
-       INTEGER(iwp) ::  jj       !: Coarse-grid index
-       INTEGER(iwp) ::  jstart   !:
-       INTEGER(iwp) ::  jr       !:
-       INTEGER(iwp) ::  k        !: Fine-grid index
-       INTEGER(iwp) ::  kk       !: Coarse-grid index
-       INTEGER(iwp) ::  kstart   !:
-       REAL(wp)     ::  xi       !:
-       REAL(wp)     ::  eta      !:
-       REAL(wp)     ::  zeta     !:
+       INTEGER(iwp) ::  i        !< Fine-grid index
+       INTEGER(iwp) ::  ifc_o    !<
+       INTEGER(iwp) ::  ifc_u    !<
+       INTEGER(iwp) ::  ii       !< Coarse-grid index
+       INTEGER(iwp) ::  istart   !<
+       INTEGER(iwp) ::  ir       !<
+       INTEGER(iwp) ::  j        !< Fine-grid index
+       INTEGER(iwp) ::  jj       !< Coarse-grid index
+       INTEGER(iwp) ::  jstart   !<
+       INTEGER(iwp) ::  jr       !<
+       INTEGER(iwp) ::  k        !< Fine-grid index
+       INTEGER(iwp) ::  kk       !< Coarse-grid index
+       INTEGER(iwp) ::  kstart   !<
+       REAL(wp)     ::  xi       !<
+       REAL(wp)     ::  eta      !<
+       REAL(wp)     ::  zeta     !<
      
 !
@@ -2490,5 +2605,5 @@
        DO  ii = icl, icr-1
           i = istart
-          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.   &
+          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  &
                       ( i < nxrg ) )
              i  = i + 1
@@ -2496,5 +2611,5 @@
           iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
           ir = i
-          DO  WHILE ( ( coord_x(ir) <= cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND. &
+          DO  WHILE ( ( coord_x(ir) <= cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.&
                       ( i < nxrg+1 ) )
              i  = i + 1
@@ -2512,5 +2627,5 @@
        DO  ii = icl, icr-1
           i = istart
-          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.      &
+          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.     &
                       ( i < nxrg ) )
              i  = i + 1
@@ -2518,5 +2633,5 @@
           iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
           ir = i
-          DO  WHILE ( ( coord_x(ir) + 0.5_wp * dx <= cg%coord_x(ii) + cg%dx )   &
+          DO  WHILE ( ( coord_x(ir) + 0.5_wp * dx <= cg%coord_x(ii) + cg%dx )  &
                       .AND.  ( i < nxrg+1 ) )
              i  = i + 1
@@ -2534,5 +2649,5 @@
        DO  jj = jcs, jcn-1
           j = jstart
-          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.   &
+          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  &
                       ( j < nyng ) )
              j  = j + 1
@@ -2540,5 +2655,5 @@
           jflv(jj) = MIN( MAX( j, nysg ), nyng )
           jr = j
-          DO  WHILE ( ( coord_y(jr) <= cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND. &
+          DO  WHILE ( ( coord_y(jr) <= cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.&
                       ( j < nyng+1 ) )
              j  = j + 1
@@ -2556,5 +2671,5 @@
        DO  jj = jcs, jcn-1
           j = jstart
-          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.      &
+          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.     &
                       ( j < nyng ) )
              j  = j + 1
@@ -2562,5 +2677,5 @@
           jflo(jj) = MIN( MAX( j, nysg ), nyng )
           jr = j
-          DO  WHILE ( ( coord_y(jr) + 0.5_wp * dy <= cg%coord_y(jj) + cg%dy )   &
+          DO  WHILE ( ( coord_y(jr) + 0.5_wp * dy <= cg%coord_y(jj) + cg%dy )  &
                       .AND.  ( j < nyng+1 ) )
              j  = j + 1
@@ -2636,10 +2751,10 @@
           DO  ii = icl, icr
              IF ( ifuu(ii) < ( nx + 1 ) / 2 )  THEN   
-                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                          &
+                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                         &
                      lower_left_coord_x ) ) / anterp_relax_length_l )**4
                 frax(ii) = xi / ( 1.0_wp + xi )
              ELSE
-                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -    &
-                                      cg%coord_x(ii) ) ) /                      &
+                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -   &
+                                      cg%coord_x(ii) ) ) /                     &
                        anterp_relax_length_r )**4
                 frax(ii) = xi / ( 1.0_wp + xi )                
@@ -2650,10 +2765,10 @@
           DO  jj = jcs, jcn
              IF ( jfuv(jj) < ( ny + 1 ) / 2 )  THEN 
-                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                         &
+                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                        &
                      lower_left_coord_y ) ) / anterp_relax_length_s )**4
                 fray(jj) = eta / ( 1.0_wp + eta )
              ELSE
-                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -   &
-                                       cg%coord_y(jj)) ) /                      &
+                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -  &
+                                       cg%coord_y(jj)) ) /                     &
                         anterp_relax_length_n )**4
                 fray(jj) = eta / ( 1.0_wp + eta )
@@ -2683,17 +2798,17 @@
        IMPLICIT NONE
 
-       INTEGER(iwp)        ::  k                     !: index variable along z
-       INTEGER(iwp)        ::  k_wall                !: topography-top index along z
-       INTEGER(iwp)        ::  kc                    !:
-
-       REAL(wp), PARAMETER ::  cfw = 0.2_wp          !:
-       REAL(wp), PARAMETER ::  c_tkef = 0.6_wp       !:
-       REAL(wp)            ::  fw                    !:
-       REAL(wp), PARAMETER ::  fw0 = 0.9_wp          !:
-       REAL(wp)            ::  glsf                  !:
-       REAL(wp)            ::  glsc                  !:
-       REAL(wp)            ::  height                !:
-       REAL(wp), PARAMETER ::  p13 = 1.0_wp/3.0_wp   !:
-       REAL(wp), PARAMETER ::  p23 = 2.0_wp/3.0_wp   !:        
+       INTEGER(iwp)        ::  k                     !< index variable along z
+       INTEGER(iwp)        ::  k_wall                !< topography-top index along z
+       INTEGER(iwp)        ::  kc                    !<
+
+       REAL(wp), PARAMETER ::  cfw = 0.2_wp          !<
+       REAL(wp), PARAMETER ::  c_tkef = 0.6_wp       !<
+       REAL(wp)            ::  fw                    !<
+       REAL(wp), PARAMETER ::  fw0 = 0.9_wp          !<
+       REAL(wp)            ::  glsf                  !<
+       REAL(wp)            ::  glsc                  !<
+       REAL(wp)            ::  height                !<
+       REAL(wp), PARAMETER ::  p13 = 1.0_wp/3.0_wp   !<
+       REAL(wp), PARAMETER ::  p23 = 2.0_wp/3.0_wp   !<        
 
        IF ( nest_bound_l )  THEN
@@ -2711,5 +2826,5 @@
                 height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2732,5 +2847,5 @@
                 height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2753,5 +2868,5 @@
                 height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw*height / glsf )
-                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
                      ( glsf / glsc )**p23 )
              ENDDO
@@ -2812,6 +2927,6 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i   !:
-    INTEGER(iwp) ::  j   !:
+    INTEGER(iwp) ::  i   !<
+    INTEGER(iwp) ::  j   !<
 
 !
@@ -2838,22 +2953,25 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN)          ::  child_id    !:
-    INTEGER, INTENT(IN)          ::  nz_cl       !:
-    INTEGER, INTENT(IN),OPTIONAL ::  n           !< index of chemical species
-
-    CHARACTER(LEN=*), INTENT(IN) ::  name        !:
+    INTEGER(iwp), INTENT(IN)          ::  child_id    !<
+    INTEGER(iwp), INTENT(IN)          ::  nz_cl       !<
+    INTEGER(iwp), INTENT(IN),OPTIONAL ::  n           !< index of chemical species
+
+    CHARACTER(LEN=*), INTENT(IN) ::  name        !<
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  ierr        !:
-    INTEGER(iwp) ::  istat       !:
-
-    REAL(wp), POINTER, DIMENSION(:,:)   ::  p_2d        !:
-    REAL(wp), POINTER, DIMENSION(:,:)   ::  p_2d_sec    !:
-    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d        !:
-    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d_sec    !:
+    INTEGER(iwp) ::  ierr        !<
+    INTEGER(iwp) ::  istat       !<
+
+    REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d        !<
+    REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d_sec    !<
+    REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d        !<
+    REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d_sec    !<
+    INTEGER(idp), POINTER, DIMENSION(:,:) ::  i_2d        !<
 
 
     NULLIFY( p_3d )
     NULLIFY( p_2d )
+    NULLIFY( i_2d )
+
 !
 !-- List of array names, which can be coupled.
@@ -2870,4 +2988,6 @@
     IF ( TRIM(name) == "nc" )  p_3d => nc
     IF ( TRIM(name) == "s"  )  p_3d => s
+    IF ( TRIM(name) == "nr_part"  )   i_2d => nr_part
+    IF ( TRIM(name) == "part_adr"  )  i_2d => part_adr
     IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d => chem_species(n)%conc
 
